<component xmlns:xi="http://www.w3.org/2001/XInclude">
  <actions>
    <group id="LookupActions">
      <!-- these must be declared before standard EnterAction and TabAction -->
      <action id="EditorChooseLookupItem" class="com.intellij.codeInsight.lookup.impl.actions.ChooseItemAction"/>
      <action id="EditorChooseLookupItemReplace" class="com.intellij.codeInsight.lookup.impl.actions.ChooseItemReplaceAction"/>
      <action id="EditorChooseLookupItemCompleteStatement" class="com.intellij.codeInsight.lookup.impl.actions.ChooseItemCompleteStatementAction"/>

      <action id="NextTemplateVariable" class="com.intellij.codeInsight.template.impl.actions.NextVariableAction"/>
      <action id="PreviousTemplateVariable" class="com.intellij.codeInsight.template.impl.actions.PreviousVariableAction"/>

      <action id="NextParameter" class="com.intellij.codeInsight.hint.actions.NextParameterAction"/>
      <action id="PrevParameter" class="com.intellij.codeInsight.hint.actions.PrevParameterAction"/>
    </group>
  </actions>

  <xi:include href="/idea/PlatformActions.xml" xpointer="xpointer(/component/*)"/>
  <xi:include href="/idea/VcsActions.xml" xpointer="xpointer(/component/*)"/>
  <xi:include href="/idea/LangActions.xml" xpointer="xpointer(/component/*)"/>

  <actions>
    <action id="RerunFailedTests" class="com.intellij.execution.actions.AbstractRerunFailedTestsAction" icon="/runConfigurations/rerunFailedTests.png"/>

    <action id="FileChooser.GotoModule" class="com.intellij.openapi.fileChooser.actions.GotoModuleDirectory"
      icon="/nodes/ModuleClosed.png">
      <add-to-group group-id="FileChooserToolbar" anchor="after" relative-to-action="FileChooser.GotoProject"/>
    </action>

    <group id="JavaGenerateGroup1">
      <action id="GenerateTestMethod" class="com.intellij.testIntegration.GenerateTestMethodAction"/>
      <action id="GenerateConstructor" class="com.intellij.codeInsight.generation.actions.GenerateConstructorAction"/>
      <action id="GenerateGetter" class="com.intellij.codeInsight.generation.actions.GenerateGetterAction"/>
      <action id="GenerateSetter" class="com.intellij.codeInsight.generation.actions.GenerateSetterAction"/>
      <action id="GenerateGetterAndSetter" class="com.intellij.codeInsight.generation.actions.GenerateGetterAndSetterAction"/>
      <action id="GenerateEquals" class="com.intellij.codeInsight.generation.actions.GenerateEqualsAction"/>

      <add-to-group group-id="GenerateGroup" anchor="first"/>
    </group>

    <group id="JavaGenerateGroup2">
      <action id="DelegateMethods" class="com.intellij.codeInsight.generation.actions.GenerateDelegateAction"/>
      <action id="GenerateSuperMethodCall" class="com.intellij.codeInsight.generation.actions.GenerateSuperMethodCallAction"/>

      <add-to-group group-id="GenerateGroup" anchor="last"/>
    </group>

    <group id="NewGroup1">
      <action id="NewClass" class="com.intellij.ide.actions.CreateClassAction"/>
      <action id="NewModuleInGroup" class="com.intellij.openapi.roots.ui.configuration.actions.NewModuleInGroupAction"
              icon="/nodes/ModuleClosed.png"/>

      <add-to-group group-id="NewGroup" anchor="first"/>
    </group>

    <!-- File -->
    <group id="OpenProjectGroup">
      <action id="NewProject" class="com.intellij.ide.actions.NewProjectAction"/>
      <action id="NewModule" class="com.intellij.openapi.roots.ui.configuration.actions.NewModuleAction"/>
      <action id="OpenProject" class="com.intellij.ide.actions.OpenProjectAction"/>

      <add-to-group group-id="FileOpenGroup" anchor="first"/>
    </group>
    <action id="NewElement" class="com.intellij.ide.actions.NewElementAction">
      <add-to-group group-id="OpenProjectGroup" anchor="after" relative-to-action="NewModule"/>
    </action>


    <action id="SaveAsNewFormat" class="com.intellij.ide.actions.SaveAsDirectoryBasedFormatAction" text="Save as Directory-Based Format...">
      <add-to-group group-id="ExportImportGroup" anchor="first"/>
    </action>

    <action id="TemplateProjectProperties" class="com.intellij.ide.actions.TemplateProjectPropertiesAction">
      <add-to-group group-id="FileSettingsGroup" anchor="last"/>
    </action>
    <action id="TemplateProjectStructure" class="com.intellij.ide.actions.TemplateProjectStructureAction">
      <add-to-group group-id="FileSettingsGroup" anchor="last"/>
    </action>

    <action id="ShowProjectStructureSettings" class="com.intellij.ide.actions.ShowStructureSettingsAction" icon="/general/projectStructure.png">
      <add-to-group group-id="FileMainSettingsGroup" anchor="after" relative-to-action="ShowSettings"/>
      <add-to-group group-id="MainToolBar" anchor="after" relative-to-action="ShowSettings"/>
    </action>

    <action id="StartupWizard" class="com.intellij.ide.startupWizard.StartupWizardAction">
      <add-to-group group-id="FileSettingsGroup" anchor="last"/>
    </action>

    <!-- Edit -->
    <reference ref="EditorCompleteStatement">
      <add-to-group group-id="EditSmartGroup" anchor="first"/>
    </reference>

    <!-- View -->

    <action id="EditorContextInfo" class="com.intellij.codeInsight.hint.actions.ShowContainerInfoAction">
      <add-to-group group-id="CodeEditorViewGroup" anchor="before" relative-to-action="ShowErrorDescription"/>
    </action>

    <action id="ExpandJavadocs" class="com.intellij.codeInsight.folding.impl.actions.ExpandJavadocsAction">
      <add-to-group group-id="LanguageSpecificFoldingGroup" anchor="last"/>
    </action>
    <action id="CollapseJavadocs" class="com.intellij.codeInsight.folding.impl.actions.CollapseJavadocsAction">
      <add-to-group group-id="LanguageSpecificFoldingGroup" anchor="last"/>
    </action>

    <action id="CollapseBlock" class="com.intellij.codeInsight.folding.impl.actions.CollapseBlockAction">
      <add-to-group group-id="FoldingGroup" anchor="after" relative-to-action="CollapseSelection"/>
    </action>

    <reference ref="DelegateMethods">
      <add-to-group group-id="CodeMenu" anchor="after" relative-to-action="ImplementMethods"/>
    </reference>

    <!-- Analyze -->
    <group id="AnalyzeMenu" popup="true">
      <separator/>
      <action id="ShowPackageDeps" class="com.intellij.packageDependencies.actions.AnalyzeDependenciesAction"/>
      <action id="ShowBackwardPackageDeps" class="com.intellij.packageDependencies.actions.BackwardDependenciesAction"/>
      <add-to-group group-id="MainMenu" anchor="after" relative-to-action="CodeMenu"/>
    </group>

    <group id="InspectCodeGroup" text="Inspect Code Actions">
      <action id="InspectCode" class="com.intellij.codeInspection.actions.CodeInspectionAction"/>
      <action id="ViewOfflineInspection" class="com.intellij.codeInspection.actions.ViewOfflineResultsAction"/>
      <add-to-group group-id="AnalyzeMenu" anchor="first"/>
    </group>


    <group id="AnalyzeJavaMenu">
      <action id="ShowPackageCycles" class="com.intellij.cyclicDependencies.actions.CyclicDependenciesAction"/>
      <action id="ShowModulesDependencies" class="com.intellij.moduleDependencies.ShowModuleDependenciesAction"/>
      <separator/>
      <action id="SliceBackward" class="com.intellij.slicer.SliceBackwardAction"/>
      <action id="SliceForward" class="com.intellij.slicer.SliceForwardAction"/>
      <separator/>
      <action id="Unscramble" class="com.intellij.unscramble.UnscrambleAction"/>

      <add-to-group group-id="AnalyzeMenu" anchor="last"/>
    </group>

    <group id="RefactoringMenu1">
      <action id="ChangeSignature" class="com.intellij.refactoring.actions.ChangeSignatureAction"/>
      
      <action id="MakeStatic" class="com.intellij.refactoring.actions.MakeStaticAction"/>
      <action id="ConvertToInstanceMethod" class="com.intellij.refactoring.actions.ConvertToInstanceMethodAction"/>
      <add-to-group group-id="RefactoringMenu" anchor="after" relative-to-action="RenameElement"/>
    </group>

    <group id="RefactoringMenu2">
      <action id="MethodDuplicates" class="com.intellij.refactoring.actions.MethodDuplicatesAction"/>
      <action id="InvertBoolean" class="com.intellij.refactoring.actions.InvertBooleanAction"/>
      <action id="IntroduceParameterObject" class="com.intellij.refactoring.actions.IntroduceParameterObjectAction"/>


      <add-to-group group-id="RefactoringMenu" anchor="before" relative-to-action="IntroduceVariable"/>
    </group>

    <action id="ExtractInterface" class="com.intellij.refactoring.extractInterface.ExtractInterfaceAction">
      <add-to-group group-id="RefactoringMenu" anchor="before" relative-to-action="ExtractSuperclass"/>
    </action>

    <group id="RefactoringMenu4">
      <action id="TurnRefsToSuper" class="com.intellij.refactoring.actions.TurnRefsToSuperAction"/>
      <action id="InheritanceToDelegation" class="com.intellij.refactoring.actions.InheritanceToDelegationAction"/>
      <action id="RemoveMiddleman" class="com.intellij.refactoring.actions.RemoveMiddlemanAction"/>
      <action id="WrapReturnValue" class="com.intellij.refactoring.wrapreturnvalue.WrapReturnValueAction"/>
      <separator/>
      <action id="AnonymousToInner" class="com.intellij.refactoring.actions.AnonymousToInnerAction"/>
      <action id="EncapsulateFields" class="com.intellij.refactoring.actions.EncapsulateFieldsAction"/>
      <action id="ReplaceTempWithQuery" class="com.intellij.refactoring.actions.TempWithQueryAction"/>
      <action id="ReplaceConstructorWithFactory" class="com.intellij.refactoring.actions.ReplaceConstructorWithFactoryAction"/>
      <action id="ReplaceConstructorWithBuilder" class="com.intellij.refactoring.actions.ReplaceConstructorWithBuilderAction"/>
      <separator/>
      <action id="Generify" class="com.intellij.refactoring.actions.TypeCookAction"/>
      <action id="Migrate" class="com.intellij.refactoring.actions.MigrateAction"/>
      <separator/>

      <add-to-group group-id="RefactoringMenu" anchor="after" relative-to-action="MemberPushDown"/>
    </group>

    <action id="ReplaceMethodWithMethodObject" class="com.intellij.refactoring.actions.ReplaceMethodWithMethodObjectAction">
      <add-to-group group-id="RefactoringMenu" anchor="after" relative-to-action="ExtractMethod"/>
    </action>

    <action id="ExtractClass" class="com.intellij.refactoring.actions.ExtractClassAction">
      <add-to-group group-id="RefactoringMenu" anchor="after" relative-to-action="ReplaceMethodWithMethodObject"/>
    </action>

    <action id="BuildAllArtifacts" class="com.intellij.compiler.actions.BuildAllArtifactsAction"/>

    <group id="BuildMenu" popup="true">
      <action id="CompileDirty" class="com.intellij.compiler.actions.CompileDirtyAction" icon="/actions/compile.png"/>
      <action id="MakeModule" class="com.intellij.compiler.actions.MakeModuleAction"/>
      <action id="Compile" class="com.intellij.compiler.actions.CompileAction"/>
      <action id="RunAPT" class="com.intellij.compiler.actions.ProcessAnnotationsAction"/>
      <separator/>
      <action id="CompileProject" class="com.intellij.compiler.actions.CompileProjectAction"/>
      <separator/>
      <action id="GenerateAntBuild" class="com.intellij.compiler.actions.GenerateAntBuildAction"/>
      <separator/>
      <group id="BuildArtifactsGroup" class="com.intellij.compiler.actions.BuildArtifactActionGroup"/>

      <add-to-group group-id="MainMenu" anchor="before" relative-to-action="RunMenu"/>
    </group>

    <action id="Hotswap" class="com.intellij.debugger.actions.HotSwapAction">
      <add-to-group group-id="DebugMainMenu" anchor="before" relative-to-action="StepOver"/>
    </action>

    <action id="Debugger.PopFrame" class="com.intellij.debugger.actions.PopFrameAction" icon="/actions/popFrame.png">
      <add-to-group group-id="DebugMainMenu" anchor="after" relative-to-action="ForceRunToCursor"/>
    </action>

    <group id="ToggleBreakpointAction">
      <action id="ToggleMethodBreakpoint" class="com.intellij.debugger.actions.ToggleMethodBreakpointAction"/>
      <action id="ToggleFieldBreakpoint" class="com.intellij.debugger.actions.ToggleFieldBreakpointAction"/>
      <action id="ToggleBreakpointEnabled" class="com.intellij.debugger.actions.ToggleBreakpointEnabledAction"/>
      <add-to-group group-id="DebugMainMenu" anchor="after" relative-to-action="ToggleLineBreakpoint"/>
    </group>

    <action id="ExportThreads" class="com.intellij.debugger.actions.ExportThreadsAction" icon="/actions/export.png">
      <add-to-group group-id="RunMenu" anchor="last"/>
    </action>
    <action id="DumpThreads" class="com.intellij.debugger.actions.ThreadDumpAction" text="Take a thread dump" icon="/actions/dump.png">
      <add-to-group group-id="RunMenu" anchor="last"/>
    </action>

    <!-- Tools -->
    <action id="GenerateJavadoc" class="com.intellij.javadoc.actions.GenerateJavadocAction">
      <add-to-group group-id="ToolsBasicGroup" anchor="after" relative-to-action="SaveFileAsTemplate"/>
    </action>

    <action id="MaintenanceAction" class="com.intellij.ide.actions.MaintenanceAction"/>

    <group id="MaintenanceGroup">
      <action id="UiDebugger" class="com.intellij.ui.debugger.ShowUiDebuggerAction"/>
      <action id="ShowRegistry" class="com.intellij.openapi.util.registry.ShowRegistryAction"/>
    </group>

    <group text="IDEA Internal Actions" internal="true">
      <separator/>
      <action id="DebugListen" internal="true" class="com.intellij.debugger.actions.ThrowDebugExceptionAction"/>
      <action id="VirtualFileInfo" internal="true" class="com.intellij.openapi.vfs.impl.local.VirtualFileInfoAction"/>
      <action id="Merge3Files" internal="true" class="com.intellij.openapi.diff.actions.MergeFilesAction"/>
      <separator/>
      <action internal="true" id="DecodeBytesAction" class="com.intellij.internal.encodings.DecodeBytesAction"/>
      <separator/>
      <action id="DumpInspectionDescriptions" internal="true" class="com.intellij.internal.DumpInspectionDescriptionsAction"/>
      <action id="DumpIntentionsDescriptions" internal="true" class="com.intellij.internal.DumpIntentionsAction"/>
      <action id="DumpConfigurationTypes" internal="true" class="com.intellij.internal.DumpConfigurationTypesAction"/>
      <separator/>
      <action id="AddTestProcessAction" internal="true" class="com.intellij.openapi.wm.impl.status.AddTestProcessAction"
              text="Add Test Process"/>
      <action id="AddTestProcessActionIndefinte" internal="true"
              class="com.intellij.openapi.wm.impl.status.AddTestProcessActionIndefinite" text="Add Test Process Indefinite"/>
      <separator/>
      <action id="TestGestureAction" class="com.intellij.openapi.keymap.impl.ui.TestGestureAction" text="Test Gesture Action"/>
      <separator/>
      <action id="MarkFileDirty" internal="true" class="com.intellij.openapi.vcs.changes.actions.MarkFileDirtyAction"
              text="Mark File Dirty"/>
      <separator/>
      <action id="GenerateVisitorByHierarchy" internal="true" class="com.intellij.internal.GenerateVisitorByHierarchyAction" text="Generate Hierarchy Visitor"/>
      <separator/>
      <action id="FocusDebugger" internal="true" class="com.intellij.internal.focus.FocusDebuggerAction" text="Start Focus Debugger"/>
      <separator/>
      <action id="DumpLookupElementWeights" internal="true" class="com.intellij.internal.DumpLookupElementWeights" text="Dump lookup element weights"/>
      <action id="CheckVfsSanity" internal="true" class="com.intellij.openapi.vfs.newvfs.persistent.CheckSanityAction" text="Check VFS sanity"/>

      <separator/>

      <action id="ScanSourceCommentsAction" internal="true" class="com.intellij.tools.ScanSourceCommentsAction" text="Dump all comments in the project"/>
      <action internal="true" id="CompilerTest" class="com.intellij.compiler.impl.javaCompiler.api.CompilerPerfTestAction" text="Test Rebuild Performance"/>

      <reference ref="MaintenanceGroup"/>

      <add-to-group group-id="Internal" anchor="last"/>
    </group>

    <!-- Help -->
    <action id="WhatsNewAction" class="com.intellij.ide.actions.WhatsNewAction">
      <add-to-group group-id="HelpMenu" anchor="after" relative-to-action="OnlineDocAction"/>
    </action>

    <!-- Toolbar -->

    <group id="ToolbarMakeGroup">
      <reference ref="CompileDirty"/>

      <add-to-group group-id="ToolbarRunGroup" relative-to-action="RunConfiguration" anchor="before"/>
    </group>

    <group id="DebuggerActions">
      <action id="Debugger.AdjustArrayRange" class="com.intellij.debugger.actions.AdjustArrayRangeAction"/>
      <action id="Debugger.Inspect" class="com.intellij.debugger.actions.InspectAction"/>
      <action id="Debugger.CopyValue" class="com.intellij.debugger.actions.CopyValueAction"/>
      <action id="Debugger.CompareValueWithClipboard" class="com.intellij.debugger.actions.CompareValueWithClipboardAction"/>
      <action id="Debugger.CustomizeContextView" class="com.intellij.debugger.actions.CustomizeContextViewAction"/>
      <action id="Debugger.CustomizeThreadsView" class="com.intellij.debugger.actions.CustomizeThreadsViewAction"/>
      <action id="Debugger.NewWatch" class="com.intellij.debugger.actions.NewWatchAction" icon="/debugger/newWatch.png"/>
      <action id="Debugger.EditWatch" class="com.intellij.debugger.actions.EditWatchAction"/>
      <action id="Debugger.EditFrameSource" class="com.intellij.debugger.actions.EditFrameSourceAction"/>
      <action id="Debugger.EditNodeSource" class="com.intellij.debugger.actions.EditSourceAction"/>
      <action id="Debugger.EditTypeSource" class="com.intellij.debugger.actions.JumpToObjectAction"/>
      <reference ref="Debugger.PopFrame"/>
      <action id="Debugger.RemoveAllWatches" class="com.intellij.debugger.actions.RemoveAllWatchesAction"/>
      <action id="Debugger.RemoveWatch" class="com.intellij.debugger.actions.RemoveWatchAction" icon="/actions/delete.png"/>
      <action id="Debugger.ViewAsGroup" class="com.intellij.debugger.actions.ViewAsGroup"/>
      <action id="Debugger.MarkObject" class="com.intellij.debugger.actions.MarkObjectAction"/>
      <action id="Debugger.SetValue" class="com.intellij.debugger.actions.SetValueAction"/>
      <!--<action id="Debugger.ShowAsHex" class="com.intellij.debugger.actions.ShowAsHexAction" text="Show as Hex"/>-->
      <action id="Debugger.ShowFrame" class="com.intellij.debugger.actions.ShowFrameAction"/>
      <action id="Debugger.ResumeThread" class="com.intellij.debugger.actions.ResumeThreadAction"/>
      <action id="Debugger.FreezeThread" class="com.intellij.debugger.actions.FreezeThreadAction"/>
      <action id="Debugger.AddToWatch" class="com.intellij.debugger.actions.AddToWatchAction" icon="/debugger/addToWatch.png"/>
      <action id="Debugger.FocusOnBreakpoint" class="com.intellij.debugger.ui.breakpoints.actions.FocusOnBreakpointAction"/>

    </group>

    <group id="Debugger.Representation">
      <action id="Debugger.AutoRenderer" class="com.intellij.debugger.actions.AutoRendererAction"/>
    </group>

    <action id="ConfigureFileDefaultEncoding" class="com.intellij.openapi.vfs.encoding.ConfigureFileDefaultEncodingAction">
      <add-to-group group-id="ChangeFileEncodingGroup" anchor="last"/>
    </action>

    <action id="AnalyzeStacktraceOnError" class="com.intellij.unscramble.AnalyzeStacktraceOnErrorAction" text="Analyze Stacktrace"/>

    <group id="EditorPopupMenu2">
      <separator/>
      <reference ref="EvaluateExpression"/>
      <reference ref="RunToCursor"/>
      <reference ref="ForceRunToCursor"/>
      <reference ref="Debugger.AddToWatch"/>
      <separator/>
      <reference ref="ToggleFieldBreakpoint"/>
      <separator/>

      <add-to-group group-id="EditorLangPopupMenu" relative-to-action="EditorPopupMenu.Run" anchor="before"/>
    </group>

    <reference ref="Compile">
      <add-to-group group-id="EditorPopupMenu.Run" anchor="first"/>
    </reference>

    <reference ref="RunAPT">
      <add-to-group group-id="EditorPopupMenu.Run" anchor="first"/>
    </reference>

    <group id="EditorTabCompileGroup">
      <reference ref="Compile"/>
      <reference ref="RunAPT"/>
      <add-to-group group-id="EditorTabPopupMenuEx" anchor="before" relative-to-action="RunContextPopupGroup"/>
    </group>

    <action id="ModuleSettings" class="com.intellij.ide.actions.ShowModulePropertiesAction"/>

    <reference ref="AnalyzeMenu">
      <add-to-group group-id="ProjectViewPopupMenu" anchor="after" relative-to-action="ReplaceInPath"/>
      <add-to-group group-id="NavbarPopupMenu" anchor="after" relative-to-action="ReplaceInPath"/>
      <add-to-group group-id="FavoritesViewPopupMenu" anchor="after" relative-to-action="ReplaceInPath"/>
      <add-to-group group-id="EditorPopupMenu1" anchor="after" relative-to-action="FindUsages"/>
    </reference>

    <group id="ProjectViewAnalysisGroup">
      <reference ref="TypeHierarchy"/>
      <reference ref="ReformatCode"/>
      <reference ref="OptimizeImports"/>

      <add-to-group group-id="ProjectViewPopupMenuModifyGroup" anchor="first"/>
    </group>

    <group id="ProjectViewCompileGroup">
      <reference ref="ToggleMethodBreakpoint"/>
      <reference ref="ToggleFieldBreakpoint"/>
      <separator/>
      <reference ref="MakeModule"/>
      <reference ref="Compile"/>
      <reference ref="RunAPT"/>

      <add-to-group group-id="ProjectViewPopupMenuRunGroup" anchor="first"/>
    </group>

    <action id="PackageFile" class="com.intellij.packaging.impl.ui.actions.PackageFileAction">
      <keyboard-shortcut first-keystroke="control shift F9" keymap="$default"/>
      <add-to-group group-id="EditorPopupMenu" anchor="after" relative-to-action="Compile"/>
      <add-to-group group-id="ProjectViewPopupMenu" anchor="before" relative-to-action="MakeModule"/>
      <add-to-group group-id="FavoritesViewPopupMenu" anchor="before" relative-to-action="MakeModule"/>
      <add-to-group group-id="ScopeViewPopupMenu" anchor="before" relative-to-action="MakeModule"/>
    </action>


    <reference ref="ModuleSettings">
      <add-to-group group-id="ProjectViewPopupMenuSettingsGroup" anchor="first"/>
    </reference>

    <group id="StructureViewCompileGroup">
      <separator/>
      <reference ref="ToggleMethodBreakpoint"/>
      <reference ref="ToggleFieldBreakpoint"/>
      <separator/>
      <reference ref="Compile"/>
      <reference ref="RunAPT"/>

      <add-to-group group-id="StructureViewPopupMenu" anchor="after" relative-to-action="RunContextPopupGroup"/>
    </group>

    <group id="TypeHierarchyPopupMenu">
      <action id="TypeHierarchy.BaseOnThisType" class="com.intellij.ide.hierarchy.type.TypeHierarchyBrowser$BaseOnThisTypeAction"/>
      <reference ref="TypeHierarchy.Class"/>
      <reference ref="TypeHierarchy.Subtypes"/>
      <reference ref="TypeHierarchy.Supertypes"/>
      <separator/>
      <reference ref="EditSource"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="RefactoringMenu"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <reference ref="RunContextPopupGroup"/>
      <separator/>
      <reference ref="ReformatCode"/>
      <reference ref="OptimizeImports"/>
      <reference ref="$Delete"/>
      <separator/>
      <reference ref="Compile"/>
      <reference ref="RunAPT"/>
      <reference ref="VersionControlsGroup"/>

      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
    </group>

    <group id="MethodHierarchyPopupMenu">
      <action id="MethodHierarchy.ImplementMethodAction" class="com.intellij.ide.hierarchy.method.ImplementMethodAction"/>
      <action id="MethodHierarchy.OverrideMethodAction" class="com.intellij.ide.hierarchy.method.OverrideMethodAction"/>
      <separator/>
      <action id="MethodHierarchy.BaseOnThisType" class="com.intellij.ide.hierarchy.method.MethodHierarchyBrowser$BaseOnThisMethodAction"/>
      <reference ref="EditSource"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="RefactoringMenu"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <reference ref="Compile"/>
      <reference ref="RunContextPopupGroup"/>
      <separator/>
      <reference ref="ReformatCode"/>
      <reference ref="OptimizeImports"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
    </group>

    <group id="CallHierarchyPopupMenu">
      <action id="CallHierarchy.BaseOnThisType" class="com.intellij.ide.hierarchy.call.CallHierarchyBrowser$BaseOnThisMethodAction"/>
      <reference ref="EditSource"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="RefactoringMenu"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <reference ref="Compile"/>
      <reference ref="RunAPT"/>
      <reference ref="RunContextPopupGroup"/>
      <separator/>

      <reference ref="ReformatCode"/>
      <reference ref="OptimizeImports"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>

      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
    </group>

    <group id="CommanderPopupMenu">
      <reference ref="NewGroup"/>
      <reference ref="AssociateWithFileType"/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <reference ref="EditSource"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="FindInPath"/>
      <reference ref="ReplaceInPath"/>
      <reference ref="InspectCode"/>
      <reference ref="ShowPackageDeps"/>
      <reference ref="RefactoringMenu"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <reference ref="TypeHierarchy"/>
      <reference ref="ReformatCode"/>
      <reference ref="OptimizeImports"/>
      <reference ref="$Delete"/>
      <separator/>
      <reference ref="Compile"/>
      <reference ref="RunAPT"/>
      <reference ref="RunContextPopupGroup"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>

      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>
    </group>

    <group id="TestStatisticsTablePopupMenu">
      <reference ref="RunContextGroup"/>
      <separator/>
      <reference ref="EditSource"/>
      <reference ref="ViewSource"/>
      <separator/>
    </group>


    <group id="Debugger.FramePanelPopup">
      <reference ref="Debugger.AdjustArrayRange"/>
      <reference ref="Debugger.Inspect"/>
      <reference ref="Debugger.MarkObject"/>
      <reference ref="Debugger.SetValue"/>
      <reference ref="Debugger.EditNodeSource"/>
      <reference ref="Debugger.EditTypeSource"/>
      <separator/>
      <reference ref="Debugger.ViewAsGroup"/>
      <separator/>
      <reference ref="Debugger.AddToWatch"/>
      <separator/>
      <reference ref="ToggleFieldBreakpoint"/>
      <separator/>
      <reference ref="Debugger.CopyValue"/>
      <reference ref="Debugger.CompareValueWithClipboard"/>
      <reference ref="Debugger.CustomizeContextView"/>
    </group>

    <group id="Debugger.EvaluationDialogPopup">
      <reference ref="Debugger.AdjustArrayRange"/>
      <reference ref="Debugger.Inspect"/>
      <reference ref="Debugger.MarkObject"/>
      <reference ref="Debugger.SetValue"/>
      <reference ref="Debugger.EditNodeSource"/>
      <reference ref="Debugger.EditTypeSource"/>
      <separator/>
      <!--<reference ref="Debugger.ShowAsHex"/>-->
      <reference ref="Debugger.ViewAsGroup"/>
      <separator/>
      <reference ref="Debugger.AddToWatch"/>
      <separator/>
      <reference ref="ToggleFieldBreakpoint"/>
      <separator/>
      <reference ref="Debugger.CopyValue"/>
      <reference ref="Debugger.CompareValueWithClipboard"/>
      <reference ref="Debugger.CustomizeContextView"/>
    </group>

    <group id="Debugger.InspectPanelPopup">
      <reference ref="Debugger.AdjustArrayRange"/>
      <reference ref="Debugger.Inspect"/>
      <reference ref="Debugger.MarkObject"/>
      <reference ref="Debugger.SetValue"/>
      <reference ref="Debugger.EditNodeSource"/>
      <reference ref="Debugger.EditTypeSource"/>
      <separator/>
      <reference ref="Debugger.AddToWatch"/>
      <separator/>
      <!--<reference ref="Debugger.ShowAsHex"/>-->
      <reference ref="Debugger.ViewAsGroup"/>
      <separator/>
      <reference ref="ToggleFieldBreakpoint"/>
      <separator/>
      <reference ref="Debugger.CopyValue"/>
      <reference ref="Debugger.CompareValueWithClipboard"/>
      <reference ref="Debugger.CustomizeContextView"/>
    </group>

    <group id="Debugger.ThreadsPanelPopup">
      <!--<reference ref="Debugger.ResumeThread"/>-->
      <!--<reference ref="Debugger.FreezeThread"/>-->
      <!--<reference ref="Debugger.ShowFrame"/>-->
      <reference ref="Debugger.PopFrame"/>
      <!--<reference ref="Debugger.EditFrameSource"/>-->
      <!--<reference ref="Debugger.EditTypeSource"/>-->
      <!--<reference ref="EditSource"/>-->
      <separator/>
      <reference ref="ExportThreads"/>
      <separator/>
      <reference ref="Debugger.CustomizeThreadsView"/>
    </group>

    <group id="Debugger.WatchesPanelPopup">
      <reference ref="Debugger.NewWatch"/>
      <reference ref="Debugger.EditWatch"/>
      <reference ref="Debugger.RemoveWatch"/>
      <reference ref="Debugger.RemoveAllWatches"/>
      <separator/>
      <reference ref="Debugger.AdjustArrayRange"/>
      <reference ref="Debugger.Inspect"/>
      <reference ref="Debugger.MarkObject"/>
      <reference ref="Debugger.SetValue"/>
      <reference ref="Debugger.EditNodeSource"/>
      <reference ref="Debugger.EditTypeSource"/>
      <separator/>
      <!--<reference ref="Debugger.ShowAsHex"/>-->
      <reference ref="Debugger.ViewAsGroup"/>
      <separator/>
      <reference ref="Debugger.AddToWatch"/>
      <separator/>
      <reference ref="ToggleFieldBreakpoint"/>
      <separator/>
      <reference ref="Debugger.CopyValue"/>
      <reference ref="Debugger.CompareValueWithClipboard"/>
      <reference ref="Debugger.CustomizeContextView"/>
    </group>


    <!--  TODO: fix
      <group id="UsageView.Popup">-->
      <!--<reference ref="EditSource"/>-->
      <!--<action id="UsageView.Include" class="com.intellij.usages.actions.IncludeUsageAction"/>-->
      <!--<action id="UsageView.Exclude" class="com.intellij.usages.actions.ExcludeUsageAction"/>-->
      <!--<separator/>-->
      <!--<reference ref="AddToFavorites"/>-->
      <!--<reference ref="MoveToChangeList"/>-->
      <!--<reference ref="FindUsages"/>-->
      <!--<action id="UsageView.ShowRecentFindUsages" class="com.intellij.find.impl.ShowRecentFindUsagesAction" icon="/actions/back.png"/>-->
      <!--<separator/>-->
      <!--<reference ref="VersionControlsGroup"/>-->
      <!--<separator/>-->
      <!--<reference ref="ExternalToolsGroup"/>-->
    <!--</group>-->

    <!-- ****************************************************************** -->

    <group id="WelcomeScreen.QuickStart.IDEA">
      <action id="WelcomeScreen.CreateNewProject" class="com.intellij.ide.actions.NewProjectAction"
        icon="/general/createNewProject.png"/>
      <action id="WelcomeScreen.OpenProject" class="com.intellij.openapi.wm.impl.welcomeScreen.WelcomeScreenOpenProjectAction"
        icon="/general/openProject.png"/>
      <action id="WelcomeScreen.ReopenRecent" class="com.intellij.openapi.wm.impl.welcomeScreen.RecentProjectsAction"
        icon="/general/reopenRecentProject.png"/>

      <add-to-group group-id="WelcomeScreen.QuickStart" anchor="first"/>
    </group>

    <group id="WelcomeScreen.Documentation.IDEA">
      <action id="WelcomeScreen.DevelopPlugins" class="com.intellij.openapi.wm.impl.welcomeScreen.DevelopPluginsAction"
        icon="/general/pluginManager.png"/>

      <add-to-group group-id="WelcomeScreen.Documentation" anchor="last"/>
    </group>

    <action id="AddFrameworkSupport" class="com.intellij.ide.util.frameworkSupport.AddFrameworkSupportAction">
      <add-to-group group-id="ProjectViewPopupMenu" anchor="after" relative-to-action="WeighingNewGroup"/>
      <add-to-group group-id="NavbarPopupMenu" anchor="after" relative-to-action="WeighingNewGroup"/>
    </action>


    <group id="DiffPanel.Toolbar.IDEA">
      <reference ref="Find"/>
      <add-to-group group-id="DiffPanel.Toolbar" anchor="after" relative-to-action="$Copy"/>
    </group>

    
  </actions>

  <xi:include href="XmlActions.xml" xpointer="xpointer(/component/*)"/>

</component>
